import 'package:domain/entity/garage_sale_rent_detail_entity.dart';
import 'package:widgets/load_state_layout.dart';

class ServiceCleanDetailState {
  //页面 LoadView 状态的展示
  LoadState loadingState;
  String? errorMessage;

  // dialog 状态的展示
  LoadState dialogLoadingState;
  String? dialogErrorMessage;

  final int? id;
  final String? type;
  double? totalPrice;
  Map<String, dynamic>? datas;

  ServiceCleanDetailState({
    this.loadingState = LoadState.State_Loading,
    this.errorMessage,
    this.dialogLoadingState = LoadState.State_Loading,
    this.dialogErrorMessage,
    this.totalPrice = 0,
    this.id,
    this.type,
    required this.datas,
  });

  ServiceCleanDetailState copyWith({
    Map<String, dynamic>? datas,
    LoadState? loadingState,
    String? errorMessage,
    LoadState? dialogLoadingState,
    String? dialogErrorMessage,
    double? totalPrice,
    int? id,
    String? type,
  }) {
    return ServiceCleanDetailState(
      loadingState: loadingState ?? this.loadingState,
      errorMessage: errorMessage ?? this.errorMessage,
      dialogLoadingState: dialogLoadingState ?? this.dialogLoadingState,
      dialogErrorMessage: dialogErrorMessage ?? this.dialogErrorMessage,
      totalPrice: totalPrice?? this.totalPrice,
      id: id ?? this.id,
      type: type ?? this.type,
      datas: datas?? this.datas,
    );
  }
}