import 'package:flutter/cupertino.dart';
import 'package:widgets/load_state_layout.dart';

class ServiceOrderConfirmState {
  //页面 LoadView 状态的展示
  LoadState loadingState;
  String? errorMessage;
  double? totalPrice;
  Map<String, Map<String, dynamic>> remarkInfo;
  Map<String, dynamic>? datas;


  ServiceOrderConfirmState({
    this.loadingState = LoadState.State_Loading,
    String? errorMessage,
    double? totalPrice,

    remarkInfo,
    this.datas,
  }): remarkInfo = remarkInfo ?? {
    "remark": {
      'value': '',
      'controller': TextEditingController(),
      'hintText': '',
      'focusNode': FocusNode(),
      'obsecure': false,
    },
  },
  totalPrice = totalPrice ?? 0.0;

  ServiceOrderConfirmState copyWith({
    LoadState? loadingState,
    String? errorMessage,
    double? totalPrice,
    Map<String, dynamic>? remarkInfo,
    Map<String, dynamic>? datas,
  }) {
    return ServiceOrderConfirmState(
      loadingState: loadingState ?? this.loadingState,
      errorMessage: errorMessage ?? this.errorMessage,
      totalPrice: totalPrice ?? this.totalPrice,
      remarkInfo: remarkInfo ?? this.remarkInfo,
      datas: datas ?? this.datas,
    );
  }
}